'use strict';

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _require = require('./model'),
    createEntryMixin = _require.createEntryMixin,
    mix = _require.mix;

var usingFieldAccessors = function usingFieldAccessors(name, spec) {
  return createEntryMixin(function (_ref) {
    var Base = _ref.Base;

    var EntryMixin = function (_Base) {
      _inherits(EntryMixin, _Base);

      function EntryMixin() {
        _classCallCheck(this, EntryMixin);

        return _possibleConstructorReturn(this, (EntryMixin.__proto__ || Object.getPrototypeOf(EntryMixin)).apply(this, arguments));
      }

      return EntryMixin;
    }(Base);

    Object.defineProperty(EntryMixin.prototype, name, Object.assign({
      enumerable: true
    }, spec));

    return EntryMixin;
  });
};

var usingFieldInitial = function usingFieldInitial(name, initial) {
  return createEntryMixin(function (_ref2) {
    var Base = _ref2.Base;
    return function (_Base2) {
      _inherits(_class, _Base2);

      function _class() {
        var _ref3;

        _classCallCheck(this, _class);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        var _this2 = _possibleConstructorReturn(this, (_ref3 = _class.__proto__ || Object.getPrototypeOf(_class)).call.apply(_ref3, [this].concat(args)));

        if (!_this2.values.has(name)) _this2[name] = initial;
        return _this2;
      }

      return _class;
    }(Base);
  });
};

var usingDefaultFieldAccessors = function usingDefaultFieldAccessors(name) {
  return usingFieldAccessors(name, {
    get: function get() {
      return this.values.get(name);
    },
    set: function set(value) {
      this.values = this.values.set(name, value);
    }
  });
};

var withInitializedField = function withInitializedField(name, _ref4) {
  var _ref4$initial = _ref4.initial,
      initial = _ref4$initial === undefined ? null : _ref4$initial;
  return mix([usingFieldInitial(name, initial), usingDefaultFieldAccessors(name)]);
};

var withField = function withField(name) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  return withInitializedField(name, options);
};

module.exports = {
  withField: withField
};
